import type { PipelineJson } from '../../pipeline/PipelineJson/PipelineJson';
import type { PipelineString } from '../../pipeline/PipelineString';
import type { string_json } from '../../types/typeAliases';
/**
 * Import the pipeline.book or pipeline.bookc file
 *
 * Note: Using here custom import to work in jest tests
 * Note: Using sync version is 💩 in the production code, but it's ok here in tests
 *
 * @param path - The path to the file relative to examples/pipelines directory
 * @private internal function of tests
 */
export declare function importPipelineWithoutPreparation(path: `${string}.book`): PipelineString;
export declare function importPipelineWithoutPreparation(path: `${string}.bookc`): PipelineJson;
/**
 * Import the pipeline.bookc file as parsed JSON
 *
 * @private internal function of tests
 */
export declare function importPipelineJson(path: `${string}.bookc`): PipelineJson;
/**
 * Import the pipeline.bookc file as string
 *
 * @private internal function of tests
 */
export declare function importPipelineJsonAsString(path: `${string}.bookc`): string_json<PipelineJson>;
/**
 * Note: [💞] Ignore a discrepancy between file name and entity name
 * Note: [⚫] Code in this file should never be published in any package
 */
