import type { string_prompt } from '../types/typeAliases';
/**
 * Tag function for notating a prompt as template literal
 *
 * Note: There are 3 similar functions:
 * 1) `prompt` for notating single prompt exported from `@promptbook/utils`
 * 2) `promptTemplate` alias for `prompt`
 * 3) `book` for notating and validating entire books exported from `@promptbook/utils`
 *
 * @param strings
 * @param values
 * @returns the prompt string
 * @public exported from `@promptbook/utils`
 */
export declare function prompt(strings: TemplateStringsArray, ...values: Array<string>): string_prompt;
/**
 * Tag function for notating a prompt as template literal
 *
 * Note: There are 3 similar functions:
 * 1) `prompt` for notating single prompt exported from `@promptbook/utils`
 * 2) `promptTemplate` alias for `prompt`
 * 3) `book` for notating and validating entire books exported from `@promptbook/utils`
 *
 * @alias prompt
 * @public exported from `@promptbook/utils`
 */
export declare const promptTemplate: typeof prompt;
/**
 * TODO: [🧠][🈴] Where is the best location for this file
 * Note: [💞] Ignore a discrepancy between file name and entity name
 */
