import type { ExecutionTools } from '../../execution/ExecutionTools';
import type { PrepareAndScrapeOptions } from '../../prepare/PrepareAndScrapeOptions';
import { BoilerplateScraper } from './BoilerplateScraper';
/**
 * Constructor of `BoilerplateScraper`
 *
 * @public exported from `@promptbook/boilerplate`
 */
export declare const createBoilerplateScraper: ((tools: Pick<ExecutionTools, 'llm'>, options: PrepareAndScrapeOptions) => BoilerplateScraper) & import("type-fest/source/readonly-deep").ReadonlyObjectDeep<{
    title: string;
    packageName: string;
    className: string;
    mimeTypes: string[];
    documentationUrl: "https://github.com/webgptorg/promptbook/discussions/@@@";
    isAvilableInBrowser: false;
    requiredExecutables: never[];
}>;
/**
 * TODO: [🎶] Naming "constructor" vs "creator" vs "factory"
 */
