import type { ExecutionTools } from '../../execution/ExecutionTools';
import type { PrepareAndScrapeOptions } from '../../prepare/PrepareAndScrapeOptions';
import { MarkitdownScraper } from './MarkitdownScraper';
/**
 * Constructor of `MarkitdownScraper`
 *
 * @public exported from `@promptbook/markitdown`
 * @public exported from `@promptbook/pdf`
 */
export declare const createMarkitdownScraper: ((tools: Pick<ExecutionTools, 'llm'>, options: PrepareAndScrapeOptions) => MarkitdownScraper) & import("type-fest/source/readonly-deep").ReadonlyObjectDeep<{
    title: string;
    packageName: string;
    className: string;
    mimeTypes: string[];
    documentationUrl: "https://github.com/webgptorg/promptbook/discussions/@@";
    isAvilableInBrowser: false;
    requiredExecutables: never[];
}>;
/**
 * TODO: [🧠][🌜] Export only from `@promptbook/markitdown` or `@promptbook/pdf` NOT both
 * TODO: [🎶] Naming "constructor" vs "creator" vs "factory"
 */
